package net.sweevo.jinks;

import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Style;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.level.ServerPlayer;
import net.sweevo.jinks.config.CommonConfig;
import net.sweevo.jinks.config.ServerConfig;

import javax.annotation.Nullable;

public class ChatHelper {

    @SuppressWarnings("null")
    public static MutableComponent component(@Nullable ServerPlayer player, String key, Object... parameters) {
        if (player != null) { return Component.translatable(key, parameters); }
        return Component.literal(String.format(key, parameters));
    }

    public static void tell(@Nullable ServerPlayer player, String chatMessage, Style style, Object... parameters) {
        MutableComponent message = ChatHelper.component(player, chatMessage, parameters);
        if (player != null) {
            player.sendSystemMessage(message.withStyle(style));
        } else {
            ExtBackup.LOGGER.info(String.valueOf(message));
        }
    }

    public static void broadcast(MinecraftServer server, String message, Style style, Object... parameters) {
        if (CommonConfig.sendMessages()) {
            server.execute(() -> server.getPlayerList().getPlayers().forEach(player -> {
                if (ServerConfig.messagesForEveryone() || player.hasPermissions(2)) {
                    player.sendSystemMessage(ChatHelper.component(player, message, parameters).withStyle(style));
                }
            }));
        }
    }
}
